﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Data.Linq;
using System.Reflection;
using System.IO;
using KillParser;
using Killboard.Models;
using System.Web;

namespace Killboard.Tests.Controllers
{
    /// <summary>
    /// Summary description for DataModelTest
    /// </summary>
    [TestClass]
    public class DataModelTest
    {
        public DataModelTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void TestDBMethod1()
        {
            Models.KillsDataContext dc = new Killboard.Models.KillsDataContext(@"Data Source=.\sqlexpress;Initial Catalog=ebs_DATADUMP;Integrated Security=True");


            var items = from c in dc.invTypes
                        where c.typeName == "Myrmidon"
                        select c;


            Assert.AreEqual(items.Count(), 1);
            
        }

        [TestMethod]
        public void TestFindItemUppercase()
        {
            Models.KillsDataContext dc = new Killboard.Models.KillsDataContext(@"Data Source=.\sqlexpress;Initial Catalog=ebs_DATADUMP;Integrated Security=True");


            var items = from c in dc.invTypes
                        where c.typeName == "MYRMIDON"
                        select c;


            Assert.AreEqual(items.Count(), 1);

        }

        [TestMethod]
        public void TestDBWithKM()
        {
            Assembly a = Assembly.GetExecutingAssembly();

            Stream s = a.GetManifestResourceStream("Killboard.Tests.Killmail2.txt");
            TextReader tr = new StreamReader(s);

            KillMail km = new KillMail();
            km.Parse(tr);

            Models.KillRepository kr = new Killboard.Models.KillRepository(@"Data Source=.\sqlexpress;Initial Catalog=ebs_DATADUMP;Integrated Security=True");

            kr.AddKill(km);
        }
    }
}
