﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using System.Web.Caching;

namespace Killboard
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    

    public class MvcApplication : System.Web.HttpApplication
    {
        public static CacheItemRemovedCallback onCacheRemove = null;

        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "Default",                                              // Route name
                "{controller}/{action}/{id}",                           // URL with parameters
                new { controller = "Home", action = "Index", id = "" }  // Parameter defaults
            );

            //support for IIS 6

            routes.MapRoute(
                "Root",
                "",
                new { controller = "Home", action = "Index", id = "" }
                );

        }

        protected void Application_Start()
        {
            RegisterRoutes(RouteTable.Routes);

            AddTask("GetKillsfromWeb", 60);

        }

        private void AddTask(string taskName, int Hours)
        {
            onCacheRemove = new CacheItemRemovedCallback(CacheItemRemoved);

            HttpRuntime.Cache.Insert(taskName, Hours, null, DateTime.Now.AddHours(Hours), Cache.NoSlidingExpiration, CacheItemPriority.NotRemovable, onCacheRemove);
        }

        public void CacheItemRemoved(string k, object v, CacheItemRemovedReason r)
        {
            System.Diagnostics.Debug.WriteLine(DateTime.Now.ToLongTimeString());

            AddTask(k, Convert.ToInt32(v));
        }
    }
}